#property copyright "Copyright 2013 - Jorsde"
#property link      ""
#property indicator_chart_window


extern string TrendName = "Gann";
extern int Cycle=144;
extern int Num_Of_Levels=8;
extern color Level_Color = DodgerBlue;
extern color Vertical_Color=Yellow; 
extern color ArrowDownColor= Red;
extern color ArrowUpColor= Yellow;

extern int BarsAhead = 12; // Number of bars ahead of current price to show line & text


/*
//The next function will draw the Gann vertical line for the time forecast
void GannExtention(datetime time,int DateDelta)
{
   time = StrToTime(TimeToStr(DateDelta, TIME_DATE) + " " + " " + " ");
   ObjectCreate("Gann Time Extention", OBJ_VLINE, 0, time, 0);
   ObjectSet("Gann Time Extention",OBJPROP_COLOR,Vertical_Color); 
   ObjectSet("Gann Time Extention",OBJPROP_WIDTH,2);
   ObjectSet("Gann Time Extention", OBJPROP_BACK, true);
}
*/

//The next function will draw Gann levels determine by the number of levels
void DrawGannLines(double P1,double P2,datetime T1,datetime T2,int HighBarsBack,int LowBarsBack)
{
   double Range,Cal_Val,Temp;

   if(P1>P2) 
   {
      Range = P1-P2; // Calculate the range between high and low 
      Temp=P2; //Give Temp the lowest value so it will start drawing the lines from bottom up
   }
   else  
   {
      Range = P2-P1; // Calculate the range between high and low 
      Temp=P1; //Give Temp the lowest value so it will start drawing the lines from bottom up
   }
   
   Cal_Val=Range/Num_Of_Levels; // calculate the delta between the levels
   Num_Of_Levels = Num_Of_Levels+1; 
   
   if(HighBarsBack>LowBarsBack){int length = HighBarsBack;} else{length = LowBarsBack;}
   Print("Value of HighBarsBack ", HighBarsBack);
   Print("Value of LowBarsBack ", LowBarsBack);
   Print("Value of length ", length);
   Print("Value of P1 ", P1);
   Print("Value of P2 ", P2);
   Print("Value of T1 ", T1);
   Print("Value of T2 ", T2);
   
   for(int i=0; i<Num_Of_Levels; i++)
   {
      switch (i)
      {
         case 0: ObjectCreate("0", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("0",OBJPROP_COLOR,Level_Color); ObjectSet("0",OBJPROP_WIDTH,2);  break; 
            Level("0",P1,P2,Time[length]);
         case 1: ObjectCreate("1", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("1",OBJPROP_COLOR,Level_Color); ObjectSet("1",OBJPROP_WIDTH,2);  break;
            Level("1",P1,P2,Time[length]);
         case 2: ObjectCreate("2", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("2",OBJPROP_COLOR,Level_Color); ObjectSet("2",OBJPROP_WIDTH,2);  break;
            Level("2",P1,P2,Time[length]);
         case 3: ObjectCreate("3", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("3",OBJPROP_COLOR,Level_Color); ObjectSet("3",OBJPROP_WIDTH,2);  break;
            Level("3",P1,P2,Time[length]);
         case 4: ObjectCreate("4", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("4",OBJPROP_COLOR,Level_Color); ObjectSet("4",OBJPROP_WIDTH,2);  break;
            Level("4",P1,P2,Time[length]);
         case 5: ObjectCreate("5", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("5",OBJPROP_COLOR,Level_Color); ObjectSet("5",OBJPROP_WIDTH,2);  break;
            Level("5",P1,P2,Time[length]);
         case 6: ObjectCreate("6", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("6",OBJPROP_COLOR,Level_Color); ObjectSet("6",OBJPROP_WIDTH,2);  break;
            Level("6",P1,P2,Time[length]);
         case 7: ObjectCreate("7", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("7",OBJPROP_COLOR,Level_Color); ObjectSet("7",OBJPROP_WIDTH,2);  break;
            Level("7",P1,P2,Time[length]);
         case 8: ObjectCreate("8", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("8",OBJPROP_COLOR,Level_Color); ObjectSet("8",OBJPROP_WIDTH,2);  break;
            Level("8",P1,P2,Time[length]);
         case 9: ObjectCreate("9", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("9",OBJPROP_COLOR,Level_Color); ObjectSet("9",OBJPROP_WIDTH,2);  break;
            Level("9",P1,P2,Time[length]);
         case 10: ObjectCreate("10", OBJ_HLINE, 0,Time[0], Temp); ObjectSet("10",OBJPROP_COLOR,Level_Color); ObjectSet("10",OBJPROP_WIDTH,2); break;
            Level("10",P1,P2,Time[length]);
         default:  break;
      }
      Temp = Temp+Cal_Val;   
   }
}




void Level(string Levels, double start, double end, double time)
{
   ObjectDelete(Levels);
   Print("In Function Levels - Delete ", Levels);
   if(ObjectFind(Levels)!=0)
   { 
      ObjectCreate(Levels, OBJ_TREND, 0, 0, start, (Time[0]+BarsAhead*Period()*60), end);
      ObjectSet(Levels,OBJPROP_RAY,false);
      ObjectSet(Levels,OBJPROP_BACK,true);
      ObjectSet(Levels,OBJPROP_TIME1,time);
   }
   else
      ObjectMove(Levels, 0, 0, (Time[0]+BarsAhead*Period()*60));
      Print("Moving Coordinates Of ", Levels);
} 


int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
{ 
   double P1=0, P2=0;
   double LowValue=0;
   datetime T1,T2;
   int HighBarsBack = 0;
   int LowBarsBack = 0;

   if (ObjectType(TrendName)== OBJ_TREND)
   {
      P1 = ObjectGet(TrendName, OBJPROP_PRICE1);
      T1 = ObjectGet(TrendName, OBJPROP_TIME1);
      P2 = ObjectGet(TrendName, OBJPROP_PRICE2);
      T2 = ObjectGet(TrendName, OBJPROP_TIME2);
      LowBarsBack = iBarShift(NULL, 0, T2);
      HighBarsBack = iBarShift(NULL, 0, T1);
   }
   else
   {
      //   ClearChart();
      return(0);
   }
       
    //   int DateRange,DateDelta; // For the vertical line
      /*  if(T1>T2) // make sure that the DateRange and DateDelta are positive
       {
            DateRange=T1 - T2; 
            DateDelta=DateRange+T1;
       }
       else
       {
            DateRange=T2-T1;
            DateDelta=DateRange+T2;
       }*/
     //  GannExtention(time,DateDelta);
       DrawGannLines(P1,P2,T1,T2, HighBarsBack,LowBarsBack);
   return(0);
}
  
  